'#Reference {00020905-0000-0000-C000-000000000046}#8.5#0#C:\Program Files (x86)\Microsoft Office\Office14\MSWORD.OLB#Microsoft Word 14.0 Object Library
' MeasureQA.bas for FilmStar MEASURE 32 bit
' Copyright 2009-2012 FTG Software Associates
'
'*********************************************************
'      Warning: Save modified program with new name!!!
'*********************************************************
'
' This program prints a QA document in Word 97-2010
' Updated 11.27.2012 for Word 2010 (32 bit)

'*********************************************************
'                   DOESN'T WORK?
'   1.  Verify that Microsoft Word Object Library
'       is checked in Edit...References. This depends
'       on your current version of Word
'
'   2.  Check that MeasureQA.doc is available
'*********************************************************

'#Uses "KillProcess.bas"

Option Explicit
DefInt I-N
DefSng A-H, O-Z

Dim dWord As Word.Application
Dim Customer$, WorkOrder$, PartID$, kPreview

' *********** Change as required ***********
Const SourceDoc$ = "\Word 2010\MeasureQA.doc"
Const dName$ = "William F. Cody"
' ******************************************

Const TmpDir$ = "c:\Windows\Temp\"

Sub Main
    Dim k, kf, f$
    Set dWord = New Word.Application
    On Error Resume Next
    MainEvents = True   ' if False, document will not print
    PlotClose  ' just in case it's open
    GraphSetup ' set FSPlot configuration for printer
    Do
        If UserInputOK() Then
            Exit Do
        Else
            If MsgBox("Invalid Part Information entered; click Cancel to quit", vbRetryCancel + vbExclamation, "MEASURE QA") = vbCancel Then End
        End If
    Loop
    DataClear: AxesDraw: Scan  ' do the scan
    Kill TmpDir & "temp.wmf"
    GraphSetup: PlotActivate: PlotNext: PlotSave TmpDir & "temp"
    Wait 1: PlotClose
    If kPreview = 1 Then MainWindow 1: Wait 1
    PrintDoc: Wait 1
    ' If kPreview = 1 then MsgBox "Click OK to proceed", vbOkOnly, "QA MEASURE"  ' possibility to save file
    dWord.Quit False
    Wait 2
    DoEvents
    Set dWord = Nothing
    KillProcess "WINWORD.EXE"   ' insurance that Word process was closed, probably not needed
    If kPreview = 1 Then MainWindow 0
End Sub

Sub PrintDoc()
    On Error Resume Next
    dWord.Documents.Open FileName:= PgmPath & SourceDoc$
    If kPreview Then dWord.Visible=True
    With dWord.ActiveDocument
        .Variables("NAME").Value = dName$
        .InlineShapes.AddPicture  TmpDir & "temp.wmf", False, True, .Bookmarks("Graph").Range
        SetTable 1, 400, 450
        SetTable 2, 550, 650
        SetTable 3, 750, 800
        .Variables("CUSTOMER").Value = Customer$
        .Variables("WORKORDER").Value = WorkOrder$
        .Variables("PARTID").Value = PartID$
        .Fields.Update
        DoEvents
        If kPreview = 1 Then
            .PrintPreview
            If MsgBox("Print the document?",vbYesNo, "MEASURE QA") = vbYes Then
                .PrintOut
                Wait 2 ' Ensure print started before closing Word
            End If
        Else
            .PrintOut
            Wait 2     ' Ensure print started before closing Word
        End If
    End With
End Sub

Sub SetTable(k, wMin, wMax) ' simplifies filling data table
    Dim yMin, yMax, yAve, s$
    s$ = CStr(k)
    AveCalc yMin, yMax, yAve, wMin, wMax
    With dWord.ActiveDocument
        .Variables("RANGE" & s$).Value = Format$(wMin, "0.0") & " to " & Format$(wMax, "0.0") & " nm"
        .Variables("MIN" & s$) = Format$(yMin, "0.00") & "%"
        .Variables("MAX" & s$) = Format$(yMax, "0.00") & "%"
        .Variables("AVE" & s$) = Format$(yAve, "0.00") & "%"
    End With
End Sub

Function UserInputOK() As Boolean
    Const L2$ = vbLf & vbLf
    Customer = IniString("Measure QA", "Customer")
    WorkOrder = IniString("Measure QA", "Work Order")
    kPreview = Val(IniString("Measure QA", "Print Preview"))
    Begin Dialog UserDialog 390,170,"Enter Part Information" ' %GRID:5,5,1,1
        Text 25,22,115,15,"&Customer",.lblCustomer,1
        TextBox 150,20,190,20,.txtCustomer
        Text 45,52,95,15,"&Work Order",.lblWork,1
        TextBox 150,50,190,20,.txtWork
        Text 15,82,125,15,"Part &ID Number",.lblID,1
        TextBox 150,80,190,20,.txtID
        CheckBox 150,110,185,15,"&Print Preview",.chkPreview
        OKButton 105,140,75,20
        CancelButton 210,140,80,20
    End Dialog
    Dim dlg As UserDialog
    With dlg
        .txtCustomer = Customer$
        .txtWork = WorkOrder$
        .txtID = PartID$
        .chkPreview = kPreview
    End With
    On Error GoTo CancelClick
    Dialog dlg
    On Error Resume Next
    With dlg
        Customer$ = .txtCustomer
        WorkOrder$ = .txtWork
        PartID$ = .txtID
        kPreview = .chkPreview
    End With
    If Customer$ = "" Or WorkOrder$ = "" Or PartID$ = "" Then
        MsgBox "Blank entries not permitted", vbExclamation, "MEASURE QA"
        UserInputOK = False
        Exit Function
    Else
        If MsgBox("Customer: " & Customer$ & L2$ & "WorkOrder: " & WorkOrder$ & L2$ & "Part ID: " & PartID$ & _
          L2$ & "Are these entries correct?", vbYesNo + vbQuestion, "Verify Input") = vbYes Then
            UserInputOK = True ' re-enter data
            WriteIniString "Measure QA", "Customer", Customer$
            WriteIniString "Measure QA", "Work Order", WorkOrder$
            WriteIniString "Measure QA", "Print Preview", CStr(kPreview)
        Else
            UserInputOK = False ' re-enter data
        End If
    End If
    Exit Function
CancelClick:
    UserInputOK = False
    Exit Function
End Function

Sub GraphSetup
    ' FSPlot graph setup code for FilmStar BASIC:
    PlotConfig 25551042, 100430, 0   ' metafile
    PlotSize 9000, 7155, 76
    PlotTitleFont = "Arial"
    PlotTitleSize = 110
    PlotLegendSize = 100
    PlotAxesFont = "Arial"
    PlotAxesLabelSize = 110
    PlotAxesNumberSize = 110
    PlotFontFixed = False
    PlotFontFixedSize = 2
    PlotAxesConfig = 0
    PlotEdgeSpace 75, 45, 45, 45
    PlotAxesSpace .15, .4, .5, 2.25
    PlotBitmapMode = False
End Sub
